	title	Playwav - Siekmanski 2004
         .386
         .model flat, stdcall
         option casemap :none   ; Case sensitive
   
	include	\masm32\include\windows.inc
	include	\masm32\include\user32.inc
	include	\masm32\include\kernel32.inc
	include	\masm32\include\comdlg32.inc
	include	\masm32\include\winmm.inc

      include	dx9macros.inc
      include	dsound9.inc

	includelib  \masm32\lib\user32.lib
	includelib  \masm32\lib\kernel32.lib
	includelib	\masm32\lib\comdlg32.lib
	includelib	\masm32\lib\winmm.lib

	includelib	dsound.lib


.data

align	4

hDSCombobox			dd 0
dwSoundCards		dd 0
SoundCardNumber		dd 0
SoundCardGuids		dd 20 dup (0)

g_pDS				LPDIRECTSOUND8		NULL
g_pDSWavSample		LPDIRECTSOUNDBUFFER8	NULL

dshWnd				dd 0
hInst				dd 0
String_buffer		db 128 dup (0)

OpenTitel			db "Open Wav file",0
OpenFilter			db "Wav files",0,"*.wav",0,0
FilenaamPlusPad		db 260 dup(0)
Filenaam			db 128 dup(0)
ofn					OPENFILENAME <> 
szString_buffer		db 256 dup(0)
.code

Load_wav proc Wav_name:DWORD,pDSBuffer:DWORD
LOCAL w_pDSSample:LPDIRECTSOUNDBUFFER8
LOCAL dsbdesc:DSBUFFERDESC
LOCAL hMmio:DWORD
LOCAL WaveInfo:MMCKINFO
LOCAL ChunkInfo:MMCKINFO
LOCAL wfx:WAVEFORMATEX
LOCAL S_data:DWORD
LOCAL S_lengte:DWORD

	mov			eax,pDSBuffer	; get the soundbuffer adres
	mov			eax,[eax]
	mov			w_pDSSample,eax ; save adres

	SAFE_RELEASE 	w_pDSSample ; release in case it is an old sample

	;Open the WAV-file and get all info
	invoke	mmioOpen,Wav_name,NULL,MMIO_ALLOCBUF or MMIO_READ	; Open the WAV file
	.if (eax)
		mov		hMmio,eax
		mov		WaveInfo.fccType,"EVAW"	; WAVE header info
		invoke	mmioDescend,hMmio,addr WaveInfo,NULL,MMIO_FINDRIFF
		.if (eax)
			invoke	MessageBox,NULL,TEXT_("this is not a wav file..."),TEXT_("Wav read error"),MB_OK OR MB_ICONERROR
			jmp		Load_wav_error
		.endif
		mov		ChunkInfo.ckid," tmf"		; fmt  field in WAVE header
		invoke	mmioDescend,hMmio,addr ChunkInfo,addr WaveInfo,MMIO_FINDCHUNK
		.if (eax)
			invoke	MessageBox,NULL,TEXT_("FMT Chunk not found..."),TEXT_("Wav read error"),MB_OK OR MB_ICONERROR
			jmp		Load_wav_error
		.endif
		invoke	mmioRead,hMmio,addr wfx,ChunkInfo.ckSize	; read Wave Format Header
		.if (eax != ChunkInfo.ckSize)
			invoke	MessageBox,NULL,TEXT_("Wave Format Info Read Error..."),TEXT_("Wav read error"),MB_OK OR MB_ICONERROR
			jmp		Load_wav_error
		.endif
		invoke	mmioAscend,hMmio,addr ChunkInfo,NULL
		mov		ChunkInfo.ckid,"atad"	; Wave Data
		invoke	mmioDescend, hMmio,addr ChunkInfo,addr WaveInfo,MMIO_FINDCHUNK
		.if (eax)
			invoke	MessageBox,NULL,TEXT_("DATA Chunk not found..."),TEXT_("Wav read error"),MB_OK OR MB_ICONERROR
			jmp		Load_wav_error
		.endif


	; Init a Directsound buffer with the Info we found in the Wav-file
	invoke		RtlZeroMemory,ADDR dsbdesc,sizeof dsbdesc
   mov			dsbdesc.dwSize,sizeof DSBUFFERDESC
   mov			dsbdesc.dwFlags,DSBCAPS_GLOBALFOCUS
	mov			eax,ChunkInfo.ckSize		; Wav-data size
	mov			dsbdesc.dwBufferBytes,eax
	lea			eax,wfx						; Wav-data format
	mov			dsbdesc.lpwfxFormat,eax
	lea			eax,dsbdesc.guid3DAlgorithm
	GUID_COPY	eax,GUID_(DS3DALG_DEFAULT)
	; create the soundbuffer
	coinvoke	g_pDS,IDirectSound8,CreateSoundBuffer,addr dsbdesc,addr w_pDSSample,NULL 
	.if (eax != DS_OK)
		invoke	MessageBox, NULL, TEXT_("CreateSoundBuffer..."), TEXT_("DSound Error"),MB_OK OR MB_ICONERROR
		jmp		Load_wav_error
	.endif

	; lock and get the adres of the soundbuffer
	coinvoke	w_pDSSample,IDirectSoundBuffer8,Lock,0,ChunkInfo.ckSize,addr S_data,addr S_lengte,NULL,0,0 
	.if (eax != DS_OK)
		invoke	MessageBox, NULL, TEXT_("Lock SoundBuffer..."), TEXT_("DSound Error"),MB_OK OR MB_ICONERROR
		jmp		Load_wav_error
	.endif

	; Read the wave data into the soundbufffer
	invoke		mmioRead,hMmio,S_data,ChunkInfo.ckSize

	; unlock the soundbuffer
	coinvoke	w_pDSSample,IDirectSoundBuffer8,Unlock,S_data,S_lengte,NULL,0 
	.if (eax != DS_OK)
		invoke	MessageBox, NULL, TEXT_("Unlock SoundBuffer..."), TEXT_("DSound Error"),MB_OK OR MB_ICONERROR
		jmp		Load_wav_error
	.endif
	; set sample start position
	coinvoke	w_pDSSample,IDirectSoundBuffer8,SetCurrentPosition,0 
.else
	invoke		MessageBox,NULL,TEXT_("wav file not found..."),TEXT_("Wav read error"),MB_OK OR MB_ICONERROR
	jmp			No_wav
.endif
	xor			ecx,ecx
	xor			edx,edx
	mov			eax,wfx.nSamplesPerSec
	mov			cx,wfx.wBitsPerSample 
	mov			dx,wfx.nChannels

   invoke		wsprintf,addr String_buffer,TEXT_(" Rate: %d BPS: %d Channels: %d Length: %d"),eax,ecx,edx,ChunkInfo.ckSize

	invoke		SetDlgItemText,dshWnd,101,addr String_buffer

	invoke		mmioClose,hMmio,NULL
	mov			eax,pDSBuffer
	mov			ecx,w_pDSSample
	mov			[eax],ecx		; save soundbuffer adres
	return		DS_OK
Load_wav_error:
	invoke		mmioClose,hMmio,NULL
	SAFE_RELEASE 	w_pDSSample
No_wav:
	invoke		SetDlgItemText,dshWnd,100,TEXT_(" no file loaded..")
	invoke		SetDlgItemText,dshWnd,101,TEXT_(" none..")
	mov			eax,pDSBuffer
	xor			ecx,ecx
	mov			[eax],ecx		; clear soundbuffer adres
	return		E_FAIL
Load_wav endp


DSoundEnumCallback proc lpGUID:DWORD,lpszDesc:DWORD,lpszDrvName:DWORD,lpContext:DWORD

	.if (lpszDesc)
		.if (lpGUID)
			mov		esi,lpGUID
			lea		edi,SoundCardGuids
			mov		eax,dwSoundCards
			mov		[edi+eax*4],esi
		.endif
			invoke	SendMessage,hDSCombobox,CB_ADDSTRING,0,lpszDesc
			inc		dwSoundCards
	.endif
	return	TRUE
DSoundEnumCallback endp


StartDSound 	proc hwnd:DWORD,Mono_stereo:DWORD,Sample_rate:DWORD,Sample_bits:DWORD,SoundCardNr:DWORD
LOCAL		dsbdesc:DSBUFFERDESC
LOCAL		wfx:WAVEFORMATEX
LOCAL		g_pDSBPrimary:LPDIRECTSOUNDBUFFER8

	lea			esi,SoundCardGuids
	mov			eax,SoundCardNr
	mov			eax,[esi+eax*4]
		
	invoke		DirectSoundCreate,eax,addr g_pDS,NULL
	.if (eax != DS_OK)
		invoke	MessageBox, NULL, TEXT_("DirectSoundCreate Failure..."), TEXT_("DSound Error"),MB_OK OR MB_ICONERROR
		return	E_FAIL
	.endif

	coinvoke	g_pDS,IDirectSound8,SetCooperativeLevel,hwnd,DSSCL_PRIORITY 
	.if (eax != DS_OK)
		invoke	MessageBox, NULL, TEXT_("SetCooperativeLevel..."), TEXT_("DSound Error"),MB_OK OR MB_ICONERROR
		return	E_FAIL
	.endif

	invoke		RtlZeroMemory,ADDR dsbdesc,sizeof dsbdesc
   mov			dsbdesc.dwSize,sizeof DSBUFFERDESC
   mov			dsbdesc.dwFlags,DSBCAPS_PRIMARYBUFFER
	coinvoke	g_pDS,IDirectSound8,CreateSoundBuffer,addr dsbdesc,addr g_pDSBPrimary,NULL 
	.if (eax != DS_OK)
		invoke	MessageBox, NULL, TEXT_("CreateSoundBuffer..."), TEXT_("DSound Error"),MB_OK OR MB_ICONERROR
		return	E_FAIL
	.endif

	invoke		RtlZeroMemory,ADDR wfx,sizeof wfx
	mov			wfx.wFormatTag,WAVE_FORMAT_PCM 
	mov			eax,Mono_stereo
	mov			wfx.nChannels,ax
	mov			eax,Sample_bits
	mov			wfx.wBitsPerSample,ax 
	mul			Mono_stereo
	shr			eax,3
	mov			wfx.nBlockAlign,ax
	mov			ecx,Sample_rate
	mov			wfx.nSamplesPerSec,ecx
	mul			ecx
 	mov			wfx.nAvgBytesPerSec,eax

	coinvoke 	g_pDSBPrimary,IDirectSoundBuffer8,SetFormat,addr wfx
	.if (eax != DS_OK)
		invoke		MessageBox, NULL, TEXT_("SetFormat Primary Buffer..."), TEXT_("DSound Error"),MB_OK OR MB_ICONERROR
		return	E_FAIL
	.endif

	SAFE_RELEASE g_pDSBPrimary
	return	DS_OK
StartDSound	endp


StopDSound 	proc
	SAFE_RELEASE 	g_pDSWavSample
	SAFE_RELEASE 	g_pDS
	return	0
StopDSound	endp


WndProc proc   hWnd:DWORD, uMsg, wParam, lParam
LOCAL    hIcon:DWORD
	.if uMsg == WM_INITDIALOG
			invoke	LoadIcon, hInst, 200
			mov	hIcon,eax
			mov		eax,hWnd
			mov		dshWnd,eax
			invoke	SendMessage,hWnd,WM_SETICON,1,hIcon

			invoke	GetDlgItem,hWnd,106
			mov		hDSCombobox,eax

			invoke	DirectSoundEnumerate,DSoundEnumCallback,NULL
			invoke	SendMessage,hDSCombobox,CB_SETCURSEL,0,0	
			
			invoke	StartDSound,hWnd,2,44100,16,NULL 	; open default device (NULL)
			.if (eax != DS_OK)
				jmp	close
			.endif

			invoke	Load_wav,TEXT_("directx4.wav"),addr g_pDSWavSample
			.if (g_pDSWavSample != 0)
				invoke		SetDlgItemText,hWnd,100,TEXT_(" directx4.wav")
				coinvoke	g_pDSWavSample,IDirectSoundBuffer8,SetCurrentPosition,0 
				coinvoke	g_pDSWavSample,IDirectSoundBuffer8,Play,0,0,0
			.endif
			return	0

	.elseif uMsg == WM_COMMAND
			mov		eax,wParam
			mov		ecx,eax
			and		eax,0ffffh
			shr		ecx,16		

		.if wParam == 102
			mov		FilenaamPlusPad[0],0
			mov		Filenaam[0],0
			mov		ofn.lStructSize,(sizeof OPENFILENAME)
			m2m		ofn.hWndOwner,hWnd
			m2m		ofn.hInstance,hInst
			m2m		ofn.lpstrFilter,offset OpenFilter
			m2m		ofn.lpstrFile,offset FilenaamPlusPad
			mov		ofn.nMaxFile,(sizeof FilenaamPlusPad)
			m2m		ofn.lpstrFileTitle,offset Filenaam
			mov		ofn.nMaxFileTitle,(sizeof Filenaam)
			m2m		ofn.lpstrTitle,offset OpenTitel
			mov		ofn.Flags,OFN_EXPLORER or OFN_FILEMUSTEXIST or OFN_LONGNAMES
			invoke	GetOpenFileName,ADDR ofn
			.if (FilenaamPlusPad[0] != 0)
				invoke	Load_wav,addr FilenaamPlusPad,addr g_pDSWavSample
		   		invoke	wsprintf,addr String_buffer,TEXT_(" %s"),addr Filenaam
				invoke	SetDlgItemText,hWnd,100,addr String_buffer
				ret
			.endif

		.elseif wParam == 103
			.if (g_pDSWavSample != 0)
				coinvoke	g_pDSWavSample,IDirectSoundBuffer8,SetCurrentPosition,0 
				invoke		GetDlgItem,hWnd,105
				invoke		SendMessage,eax,BM_GETSTATE,0,0
				.if	(eax == BST_CHECKED)
					coinvoke	g_pDSWavSample,IDirectSoundBuffer8,Play,0,0,DSBPLAY_LOOPING 
					ret
				.else
					coinvoke	g_pDSWavSample,IDirectSoundBuffer8,Play,0,0,0 
					ret
				.endif
			.endif


		.elseif wParam == 104
			.if (g_pDSWavSample != 0)
				coinvoke	g_pDSWavSample,IDirectSoundBuffer8,Stop 
				ret
			.endif
			
			.elseif ecx == CBN_SELCHANGE      
				.if eax == 106
					invoke	SendMessage,hDSCombobox,CB_GETCURSEL,0,0
					mov		SoundCardNumber,eax							
					invoke	StopDSound
					invoke	StartDSound,hWnd,2,44100,16,SoundCardNumber
					.if (eax != DS_OK)
						jmp	close
					.endif
					invoke	Load_wav,TEXT_("directx4.wav"),addr g_pDSWavSample
				.endif
			.endif



	.elseif uMsg == WM_CLOSE
close:		invoke	StopDSound
			invoke	EndDialog,hWnd,0
			return	0
	.endif
	return	0
WndProc endp

start:
	invoke	GetModuleHandle,NULL
	mov		hInst,eax
	invoke	DialogBoxParam,hInst,TEXT_("TESTDLG",0),0,addr WndProc,0
	invoke	ExitProcess,0
end start
